/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 79 "cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"
#include "poll_types.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static void* cmd_tmp;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 217 "cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CFG_TAB_H_INCLUDED
# define YY_YY_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DROP = 258,
    ASSERT = 259,
    EXIT = 260,
    RETURN = 261,
    LOG_TOK = 262,
    ERROR = 263,
    ROUTE = 264,
    ROUTE_FAILURE = 265,
    ROUTE_ONREPLY = 266,
    ROUTE_BRANCH = 267,
    ROUTE_ERROR = 268,
    ROUTE_LOCAL = 269,
    ROUTE_STARTUP = 270,
    ROUTE_TIMER = 271,
    ROUTE_EVENT = 272,
    IF = 273,
    ELSE = 274,
    SWITCH = 275,
    CASE = 276,
    DEFAULT = 277,
    BREAK = 278,
    WHILE = 279,
    FOR = 280,
    IN = 281,
    NULLV = 282,
    XDBG = 283,
    XLOG = 284,
    XLOG_BUF_SIZE = 285,
    XLOG_FORCE_COLOR = 286,
    XLOG_PRINT_LEVEL = 287,
    XLOG_LEVEL = 288,
    PV_PRINT_BUF_SIZE = 289,
    DEBUG_MODE = 290,
    ENABLE_ASSERTS = 291,
    ABORT_ON_ASSERT = 292,
    LOGLEVEL = 293,
    LOGSTDOUT = 294,
    LOGSTDERROR = 295,
    LOGFACILITY = 296,
    LOGNAME = 297,
    AVP_ALIASES = 298,
    LISTEN = 299,
    SOCKET = 300,
    MEMGROUP = 301,
    ALIAS = 302,
    AUTO_ALIASES = 303,
    TAG = 304,
    DNS = 305,
    REV_DNS = 306,
    DNS_TRY_IPV6 = 307,
    DNS_TRY_NAPTR = 308,
    DNS_RETR_TIME = 309,
    DNS_RETR_NO = 310,
    DNS_SERVERS_NO = 311,
    DNS_USE_SEARCH = 312,
    MAX_WHILE_LOOPS = 313,
    UDP_WORKERS = 314,
    CHECK_VIA = 315,
    SHM_HASH_SPLIT_PERCENTAGE = 316,
    SHM_SECONDARY_HASH_SIZE = 317,
    MEM_WARMING_ENABLED = 318,
    MEM_WARMING_PATTERN_FILE = 319,
    MEM_WARMING_PERCENTAGE = 320,
    RPM_MEM_FILE = 321,
    RPM_MEM_SIZE = 322,
    MEMLOG = 323,
    MEMDUMP = 324,
    EXECMSGTHRESHOLD = 325,
    EXECDNSTHRESHOLD = 326,
    TCPTHRESHOLD = 327,
    EVENT_SHM_THRESHOLD = 328,
    EVENT_PKG_THRESHOLD = 329,
    QUERYBUFFERSIZE = 330,
    QUERYFLUSHTIME = 331,
    SIP_WARNING = 332,
    SERVER_SIGNATURE = 333,
    SERVER_HEADER = 334,
    USER_AGENT_HEADER = 335,
    LOADMODULE = 336,
    MPATH = 337,
    MODPARAM = 338,
    MAXBUFFER = 339,
    CHROOT = 340,
    WDIR = 341,
    MHOMED = 342,
    POLL_METHOD = 343,
    TCP_ACCEPT_ALIASES = 344,
    TCP_WORKERS = 345,
    TCP_CONNECT_TIMEOUT = 346,
    TCP_CON_LIFETIME = 347,
    TCP_LISTEN_BACKLOG = 348,
    TCP_SOCKET_BACKLOG = 349,
    TCP_MAX_CONNECTIONS = 350,
    TCP_NO_NEW_CONN_BFLAG = 351,
    TCP_NO_NEW_CONN_RPLFLAG = 352,
    TCP_KEEPALIVE = 353,
    TCP_KEEPCOUNT = 354,
    TCP_KEEPIDLE = 355,
    TCP_KEEPINTERVAL = 356,
    TCP_MAX_MSG_TIME = 357,
    ADVERTISED_ADDRESS = 358,
    ADVERTISED_PORT = 359,
    DISABLE_CORE = 360,
    OPEN_FD_LIMIT = 361,
    MCAST_LOOPBACK = 362,
    MCAST_TTL = 363,
    TOS = 364,
    DISABLE_DNS_FAILOVER = 365,
    DISABLE_DNS_BLACKLIST = 366,
    DST_BLACKLIST = 367,
    DISABLE_STATELESS_FWD = 368,
    DB_VERSION_TABLE = 369,
    DB_DEFAULT_URL = 370,
    DB_MAX_ASYNC_CONNECTIONS = 371,
    DISABLE_503_TRANSLATION = 372,
    SYNC_TOKEN = 373,
    ASYNC_TOKEN = 374,
    LAUNCH_TOKEN = 375,
    AUTO_SCALING_PROFILE = 376,
    AUTO_SCALING_CYCLE = 377,
    TIMER_WORKERS = 378,
    EQUAL = 379,
    EQUAL_T = 380,
    GT = 381,
    LT = 382,
    GTE = 383,
    LTE = 384,
    DIFF = 385,
    MATCH = 386,
    NOTMATCH = 387,
    COLONEQ = 388,
    PLUSEQ = 389,
    MINUSEQ = 390,
    SLASHEQ = 391,
    MULTEQ = 392,
    MODULOEQ = 393,
    BANDEQ = 394,
    BOREQ = 395,
    BXOREQ = 396,
    OR = 397,
    AND = 398,
    BOR = 399,
    BAND = 400,
    BXOR = 401,
    BLSHIFT = 402,
    BRSHIFT = 403,
    PLUS = 404,
    MINUS = 405,
    SLASH = 406,
    MULT = 407,
    MODULO = 408,
    NOT = 409,
    BNOT = 410,
    RPAREN = 411,
    NUMBER = 412,
    ZERO = 413,
    ID = 414,
    STRING = 415,
    SCRIPTVAR = 416,
    IPV6ADDR = 417,
    IPV4ADDR = 418,
    IPNET = 419,
    COMMA = 420,
    SEMICOLON = 421,
    LPAREN = 422,
    LBRACE = 423,
    RBRACE = 424,
    LBRACK = 425,
    RBRACK = 426,
    AS = 427,
    USE_WORKERS = 428,
    USE_AUTO_SCALING_PROFILE = 429,
    MAX = 430,
    MIN = 431,
    DOT = 432,
    CR = 433,
    COLON = 434,
    ANY = 435,
    ANYCAST = 436,
    SCRIPTVARERR = 437,
    SCALE_UP_TO = 438,
    SCALE_DOWN_TO = 439,
    ON = 440,
    CYCLES = 441,
    CYCLES_WITHIN = 442,
    PERCENTAGE = 443
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 231 "cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct listen_param* listen_param;
	struct _pv_spec *specval;
	struct multi_str* multistr;

#line 460 "cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 477 "cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  206
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2298

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  189
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  85
/* YYNRULES -- Number of rules.  */
#define YYNRULES  470
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  902

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   443

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   481,   481,   484,   485,   486,   489,   490,   491,   491,
     492,   492,   493,   493,   494,   494,   495,   495,   496,   496,
     497,   497,   498,   498,   499,   499,   501,   504,   519,   528,
     543,   544,   547,   548,   562,   567,   577,   578,   581,   582,
     583,   587,   589,   591,   596,   602,   604,   608,   610,   612,
     614,   618,   621,   622,   625,   627,   629,   635,   638,   641,
     644,   647,   652,   653,   656,   657,   658,   658,   663,   663,
     670,   671,   673,   674,   677,   685,   696,   697,   698,   702,
     710,   718,   724,   732,   736,   737,   738,   739,   740,   744,
     746,   749,   750,   754,   755,   761,   762,   763,   764,   765,
     766,   767,   768,   769,   770,   771,   772,   773,   774,   775,
     776,   777,   778,   779,   780,   781,   782,   783,   784,   785,
     789,   790,   793,   797,   798,   799,   807,   815,   823,   831,
     839,   847,   855,   863,   871,   879,   882,   883,   886,   887,
     888,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     907,   908,   922,   923,   924,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,   935,   936,   937,   947,   957,
     958,   961,   962,   965,   969,   970,   973,   974,   977,   978,
     982,   983,   986,   987,   990,   991,   998,   999,  1006,  1008,
    1011,  1012,  1015,  1016,  1023,  1024,  1031,  1032,  1039,  1040,
    1042,  1043,  1047,  1048,  1051,  1052,  1054,  1055,  1057,  1059,
    1061,  1062,  1063,  1064,  1066,  1067,  1074,  1077,  1085,  1088,
    1132,  1133,  1138,  1140,  1142,  1143,  1149,  1151,  1165,  1167,
    1170,  1171,  1174,  1175,  1182,  1183,  1190,  1191,  1195,  1223,
    1224,  1226,  1227,  1230,  1231,  1234,  1235,  1245,  1247,  1249,
    1250,  1252,  1253,  1255,  1258,  1260,  1263,  1264,  1267,  1269,
    1272,  1275,  1279,  1280,  1286,  1292,  1296,  1297,  1300,  1316,
    1332,  1333,  1336,  1342,  1352,  1362,  1373,  1376,  1385,  1390,
    1413,  1418,  1426,  1442,  1445,  1451,  1454,  1462,  1468,  1471,
    1477,  1480,  1488,  1491,  1499,  1502,  1510,  1513,  1526,  1529,
    1535,  1540,  1541,  1542,  1543,  1544,  1545,  1548,  1549,  1552,
    1553,  1554,  1555,  1557,  1558,  1561,  1562,  1565,  1566,  1567,
    1570,  1586,  1591,  1592,  1593,  1595,  1600,  1603,  1606,  1609,
    1612,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,
    1627,  1631,  1632,  1633,  1634,  1635,  1636,  1639,  1642,  1645,
    1648,  1651,  1654,  1657,  1660,  1663,  1666,  1669,  1672,  1685,
    1698,  1720,  1721,  1722,  1723,  1724,  1727,  1728,  1729,  1732,
    1733,  1734,  1737,  1738,  1739,  1743,  1744,  1745,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1769,  1777,  1787,  1795,  1805,
    1813,  1831,  1840,  1841,  1843,  1844,  1847,  1853,  1859,  1865,
    1873,  1876,  1879,  1884,  1894,  1901,  1908,  1918,  1923,  1930,
    1940,  1945,  1952,  1964,  1969,  1974,  1979,  1984,  1994,  2004,
    2014,  2026,  2044,  2075,  2079,  2085,  2088,  2089,  2090,  2091,
    2092,  2094,  2096,  2098,  2100,  2102,  2103,  2106,  2112,  2113,
    2115,  2121,  2122,  2124,  2128,  2147,  2148,  2150,  2173,  2209,
    2211,  2214,  2216,  2218,  2220,  2222,  2224,  2226,  2232,  2238,
    2244
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DROP", "ASSERT", "EXIT", "RETURN",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE", "ROUTE_ONREPLY",
  "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL", "ROUTE_STARTUP",
  "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH", "CASE", "DEFAULT",
  "BREAK", "WHILE", "FOR", "IN", "NULLV", "XDBG", "XLOG", "XLOG_BUF_SIZE",
  "XLOG_FORCE_COLOR", "XLOG_PRINT_LEVEL", "XLOG_LEVEL",
  "PV_PRINT_BUF_SIZE", "DEBUG_MODE", "ENABLE_ASSERTS", "ABORT_ON_ASSERT",
  "LOGLEVEL", "LOGSTDOUT", "LOGSTDERROR", "LOGFACILITY", "LOGNAME",
  "AVP_ALIASES", "LISTEN", "SOCKET", "MEMGROUP", "ALIAS", "AUTO_ALIASES",
  "TAG", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "MAX_WHILE_LOOPS", "UDP_WORKERS", "CHECK_VIA",
  "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD", "TCPTHRESHOLD",
  "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD", "QUERYBUFFERSIZE",
  "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER",
  "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM", "MAXBUFFER",
  "CHROOT", "WDIR", "MHOMED", "POLL_METHOD", "TCP_ACCEPT_ALIASES",
  "TCP_WORKERS", "TCP_CONNECT_TIMEOUT", "TCP_CON_LIFETIME",
  "TCP_LISTEN_BACKLOG", "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS",
  "TCP_NO_NEW_CONN_BFLAG", "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE",
  "TCP_KEEPCOUNT", "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "MCAST_LOOPBACK", "MCAST_TTL", "TOS", "DISABLE_DNS_FAILOVER",
  "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST", "DISABLE_STATELESS_FWD",
  "DB_VERSION_TABLE", "DB_DEFAULT_URL", "DB_MAX_ASYNC_CONNECTIONS",
  "DISABLE_503_TRANSLATION", "SYNC_TOKEN", "ASYNC_TOKEN", "LAUNCH_TOKEN",
  "AUTO_SCALING_PROFILE", "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL",
  "EQUAL_T", "GT", "LT", "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH",
  "COLONEQ", "PLUSEQ", "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ",
  "BANDEQ", "BOREQ", "BXOREQ", "OR", "AND", "BOR", "BAND", "BXOR",
  "BLSHIFT", "BRSHIFT", "PLUS", "MINUS", "SLASH", "MULT", "MODULO", "NOT",
  "BNOT", "RPAREN", "NUMBER", "ZERO", "ID", "STRING", "SCRIPTVAR",
  "IPV6ADDR", "IPV4ADDR", "IPNET", "COMMA", "SEMICOLON", "LPAREN",
  "LBRACE", "RBRACE", "LBRACK", "RBRACK", "AS", "USE_WORKERS",
  "USE_AUTO_SCALING_PROFILE", "MAX", "MIN", "DOT", "CR", "COLON", "ANY",
  "ANYCAST", "SCRIPTVARERR", "SCALE_UP_TO", "SCALE_DOWN_TO", "ON",
  "CYCLES", "CYCLES_WITHIN", "PERCENTAGE", "$accept", "cfg", "statements",
  "statement", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "listen_id", "host_sep", "host", "proto", "port", "snumber",
  "phostport", "panyhostport", "alias_def", "id_lst", "listen_id_def",
  "socket_def_param", "socket_def_params", "socket_def", "$@10", "$@11",
  "any_proto", "multi_string", "blst_elem", "blst_elem_list",
  "auto_scale_profile_def", "assign_stm", "module_stm", "ip", "ipv4",
  "ipv6addr", "ipv6", "ipnet", "folded_string", "route_name",
  "route_name_var", "route_stm", "failure_route_stm", "onreply_route_stm",
  "branch_route_stm", "error_route_stm", "local_route_stm",
  "startup_route_stm", "timer_route_stm", "event_route_stm", "exp",
  "equalop", "compop", "matchop", "intop", "strop", "script_var",
  "exp_elem", "exp_cond", "assignop", "assignexp", "assign_cmd", "exp_stm",
  "brk_stm", "stm", "actions", "brk_actions", "action", "brk_action",
  "brk_if_cmd", "if_cmd", "while_cmd", "foreach_cmd", "switch_cmd",
  "switch_stm", "case_stms", "case_stm", "default_stm", "func_param",
  "route_param", "async_func", "cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443
};
# endif

#define YYPACT_NINF -772

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-772)))

#define YYTABLE_NINF -411

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2120,   -66,   -23,    -3,    -1,    10,    18,    26,    37,   217,
     259,   281,   298,   321,   333,   362,   368,   377,   384,   387,
     411,   428,   363,   366,   367,   383,   429,   434,   445,   447,
     476,   482,   493,   503,   536,   547,   563,   572,   580,   583,
     588,   593,   599,   600,   603,   605,   607,   609,   614,   617,
     623,    27,   628,     5,   630,   640,   642,   653,   655,   656,
     672,   673,   675,   679,   683,   692,   693,   694,   695,   705,
     708,   709,   711,   716,   722,   725,   726,   728,   736,   740,
     436,   439,   742,   743,   747,   752,   753,   757,   765,   768,
     769,  -772,    16,  1991,  -772,   120,   154,   540,   444,   469,
     575,   589,   621,   608,  -772,  -772,  -772,   188,   310,   327,
     242,   331,   332,   337,   343,   407,   358,   359,    97,    41,
     157,   261,   456,    23,   364,   374,   375,  -772,   499,  -772,
     524,  -772,   554,  -772,   578,  -772,   619,  -772,   738,   381,
     388,   389,   392,   408,   409,    56,   410,   101,   413,   320,
     324,   415,   416,   426,   427,   430,   431,   433,   435,   446,
     114,   121,  -772,  -772,   123,  -772,   473,   448,   117,   119,
     461,   134,   462,   463,   464,   465,   471,   475,   479,   170,
     189,   484,   492,   498,   501,   508,    67,   509,   512,   513,
     516,   518,   289,  -772,   739,  -772,   745,   677,   770,   125,
     146,   529,   532,   198,   533,   772,  -772,   -66,  -772,    63,
    -772,    11,  -772,    71,  -772,    24,  -772,     9,  -772,    32,
    -772,    79,  -772,    62,  -772,    65,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,   773,   777,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,   909,  -772,   686,   -35,
     480,  -772,  -772,  -772,   746,  -772,   756,  -772,  -772,  -772,
     760,   764,  -772,   -96,   767,  -772,   797,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,   744,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,   779,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,   774,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,   782,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,   775,  -772,  -772,  -772,   789,  -772,  1829,
     517,  -772,   517,  -772,  1829,   517,  -772,   517,  -772,  1829,
    -772,  1829,  -772,  1829,  -772,   517,  -772,   517,  -772,  -772,
    -772,   611,   510,   510,   150,   800,   761,  -772,   243,   794,
     761,  -772,   813,   814,   820,   807,   824,   823,   817,   830,
     833,   548,    40,    86,    88,   835,   836,   837,   838,   839,
     840,   841,   843,    91,  -772,  -772,  -772,  1305,   821,   786,
    -772,  -772,  -772,  -772,  -772,    25,  -772,  -772,  -772,   812,
     815,   819,   842,   844,   850,   879,   908,   847,   846,   845,
     851,   855,   761,   861,   862,  -772,   510,  -772,  -772,  -772,
     860,  -772,  -772,   852,  -772,  -772,  -772,   857,  -772,   -42,
     848,  -772,   867,  1301,   869,   587,  -772,  -772,  -772,   158,
    -772,   187,  -772,    58,  1301,   -73,  1301,   -73,   866,   874,
     870,   870,  -772,   174,  1008,  1009,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -772,  1516,  -772,  -772,  -772,  -772,  -772,
    -772,   871,   873,  -772,   875,   876,  -772,  -772,  -772,   880,
     878,   -53,    12,  -772,   863,  -772,  -772,  -772,  -772,  -772,
      22,   741,   892,   -40,  -772,    85,   890,  -772,  1301,  1301,
    1634,  1516,  -772,   -48,  1798,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,   904,   906,   907,   910,   899,   912,   900,
     914,  -772,  -103,  -772,   412,   915,   552,  1046,  -108,  -100,
     -24,   -12,    92,   920,   -51,   917,  -772,  -772,   681,  -772,
    -772,   -49,  -772,  -772,  1516,  -772,  1516,  -772,   864,  -772,
    1341,  -772,  1829,  1829,  1829,  1829,   916,  1829,  -772,  -772,
    -772,  -772,  -772,    54,  -772,  -772,   919,   930,   -40,  -772,
    -772,   923,  -772,   -42,  -772,   936,  -772,   557,  -772,  1075,
    1188,  1301,  1301,   931,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,   558,   293,  -772,   407,   490,  -772,  -772,  -772,
    -772,   932,  -772,   934,  -772,  -772,   596,  1682,   928,  1575,
     -73,  -772,  -772,  -772,  -772,  -772,   937,  -772,  -772,   247,
     517,  -772,   517,  -772,  -772,  -772,  -772,  -772,   712,  -772,
    1328,  1516,  1516,  1516,  1516,  1516,  1516,  1516,  1516,  1516,
    1516,  1104,  1133,  1162,  1197,   933,  1344,  -772,  -772,  -772,
    -772,   941,   598,  -772,  1073,  -772,  -772,  -772,  -772,  -772,
     946,  -772,  -772,  -772,  -772,  -772,  -772,  -772,   958,   959,
    -772,  -772,  -772,  -772,   184,  1720,  1097,  -772,  1096,   951,
     953,  -772,  1602,   954,  -772,  -772,  -772,  -772,  -772,  -772,
      70,   965,   -11,   265,   967,  -772,   216,   303,   969,  -772,
    -772,  -772,  -772,   633,   633,   633,   633,   633,  -772,  -772,
    -772,  -772,  -772,  -772,  -772,  -772,  -772,  1829,  -772,   598,
     961,   970,  -772,  -772,  -772,  -772,   652,  -772,  1377,  1682,
     816,   962,   349,  -772,  1301,  -772,  -772,   606,  -772,  -772,
    -772,  -772,  1575,  -772,  -772,  -772,  -772,  -772,   973,  -772,
    1408,   978,   -53,   252,  -772,  -772,  -772,  -772,  -772,  -772,
     956,   966,  -772,   968,  -772,  -772,   560,  -772,  -772,  -772,
    -772,   988,  -772,   -53,   981,   964,   992,  1801,  1801,  1801,
    1575,  -772,   985,   994,   995,   971,   519,   573,   639,  1137,
     999,  1004,   979,  1015,  1575,  1017,  -772,  1018,   989,  -772,
    -772,  1023,  1020,  1153,  1026,  1024,  1158,   998,  1028,  -772,
    1002,  -772
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    26,     0,     0,     4,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     6,     7,   260,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   103,     0,   105,
       0,   107,     0,   109,     0,   111,     0,   113,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   262,   261,     0,   265,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   243,     0,   245,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,     5,     3,     0,
       9,     0,    11,     0,    13,     0,    15,     0,    17,     0,
      19,     0,    21,     0,    23,     0,    25,   210,   207,   211,
     208,   212,   209,   214,     0,     0,    38,   213,   206,   205,
      89,    88,    85,    84,    87,    86,    83,    91,    90,    93,
      92,    95,    94,    97,    96,   218,     0,    35,     0,    65,
      64,   217,   216,   215,     0,   222,    32,    28,   269,   268,
       0,     0,    47,    29,     0,    51,    52,   221,    27,   266,
     270,   267,   224,   223,    99,    98,   101,   100,   102,   104,
     106,   108,   110,   112,   115,   114,   120,   118,   124,   123,
     126,   125,   128,   127,   130,   129,   132,   131,   134,   133,
     136,   135,   138,   137,   140,   139,   142,   141,   144,   143,
     146,   145,   148,   147,   150,   149,   152,   151,   154,   153,
     156,   155,   158,   157,   200,   199,   202,   201,   204,   203,
     241,   240,     0,   117,   116,   161,   160,   159,   164,   163,
     162,   166,   165,   169,   167,   168,   171,   170,   174,   172,
     176,   175,   178,   177,   180,   179,   182,   181,   184,   183,
     186,   185,   188,   187,   190,   189,   194,   193,   196,   195,
     198,   197,   192,   191,   226,    32,   225,   228,   227,   230,
     229,   232,   231,   234,   233,   236,   235,   239,   237,   238,
     242,   244,     0,   247,   249,   248,   251,   250,   253,   252,
     255,   254,   257,     0,   256,   259,   258,   121,   283,     0,
       0,   285,     0,   288,     0,     0,   290,     0,   292,     0,
     294,     0,   296,     0,   298,     0,   300,     0,    39,    40,
      44,     0,     0,     0,     0,     0,     0,    31,     0,     0,
       0,    53,     0,     0,     0,     0,     0,     0,   436,     0,
     438,   445,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   320,   384,   321,     0,     0,     0,
     373,   379,   380,   381,   382,     0,   277,   276,   278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      41,     0,     0,     0,     0,    57,    62,    69,    67,   220,
      72,   219,   271,    48,    34,    33,   119,     0,   173,     0,
       0,   122,     0,     0,     0,     0,   442,   440,   448,     0,
     451,     0,   455,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   460,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,     0,   383,   374,   281,   372,   385,
     378,     0,     0,   286,     0,     0,   291,   293,   295,     0,
       0,     0,     0,    60,    54,    59,    58,    61,    63,    73,
       0,     0,     0,     0,    77,     0,     0,   437,     0,     0,
       0,     0,   324,     0,   325,   306,   322,   363,   323,   362,
     361,   439,   444,     0,     0,     0,     0,     0,     0,     0,
       0,   279,     0,   280,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   457,   412,   414,   417,
     420,     0,   359,   360,     0,   342,     0,   341,   343,   344,
     358,   345,     0,     0,     0,     0,     0,     0,    36,    37,
      46,    43,    42,     0,    50,    49,     0,     0,     0,    70,
      71,     0,    78,     0,   246,     0,   303,     0,   365,     0,
       0,     0,     0,     0,   307,   309,   310,   311,   312,   308,
     313,   314,   315,   316,   319,     0,     0,   443,   441,   449,
     446,     0,   452,     0,   456,   453,     0,     0,     0,     0,
       0,   461,   274,   462,   275,   463,     0,   464,   434,     0,
       0,   470,     0,   459,   415,   418,   421,   458,   416,   356,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    56,    55,   263,
     264,     0,     0,    76,     0,   304,   364,   305,   302,   301,
       0,   329,   272,   273,   330,   328,   327,   326,     0,     0,
     425,   423,   424,   426,     0,     0,   397,   369,     0,     0,
       0,   393,     0,     0,   399,   366,   388,   389,   390,   391,
       0,     0,     0,     0,     0,   431,     0,     0,     0,   413,
     419,   422,   357,   352,   351,   353,   354,   355,   346,   347,
     349,   348,   350,   282,   284,   287,   289,     0,   299,     0,
       0,     0,   435,   447,   450,   454,     0,   371,     0,     0,
       0,     0,   403,   405,     0,   386,   368,     0,   376,   392,
     394,   387,     0,   465,   466,   433,   432,   467,     0,   469,
       0,     0,     0,     0,   430,   427,   428,   429,   370,   398,
       0,     0,   401,     0,   404,   402,     0,   377,   367,   375,
     400,     0,   297,     0,     0,    82,     0,   409,   407,   411,
       0,   468,     0,     0,     0,    81,     0,     0,     0,   395,
       0,     0,     0,     0,     0,     0,    74,     0,     0,   396,
      75,     0,     0,     0,     0,     0,     0,     0,     0,    80,
       0,    79
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -772,  -772,  -772,  1099,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -166,  -772,  -772,  -122,  -550,  -110,   227,
    -772,  -772,   913,  -772,  -772,  -400,  1072,  -772,  -772,   538,
     687,   544,  -772,  -772,  -772,  -772,  -259,  -772,   929,  -772,
    -698,  -457,  -390,  -772,  -772,  -772,  -772,  -772,  -772,  -772,
    -772,  -772,  -772,  -498,  -772,  -772,  -772,  -772,  -772,  -458,
    -772,  -519,  -772,   328,  -515,  -772,  -771,   390,  -422,  -118,
    -445,    73,  -772,  -505,  -672,  -490,  -372,  -772,  -772,   386,
    -772,   502,  -772,   669,  -426
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   272,   449,   273,   258,   650,   637,   259,
     260,   276,   277,   575,   506,   507,   261,   443,   442,   661,
     511,   584,   585,   414,   104,   105,   278,   279,   280,   281,
     754,   619,   489,   612,   210,   212,   214,   216,   218,   220,
     222,   224,   226,   593,   682,   683,   684,   685,   686,   477,
     595,   639,   554,   640,   478,   598,   774,   766,   479,   827,
     480,   775,   776,   481,   482,   483,   484,   821,   822,   823,
     855,   631,   764,   623,   485
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     237,   274,   491,   527,   596,   246,   165,   494,   597,   495,
     428,   496,   421,   651,   -68,   596,   206,   596,   599,   597,
     386,   597,   652,   654,   265,   426,   559,   777,   162,   599,
     655,   599,   490,   430,   558,   492,   614,   493,   616,   315,
     317,   528,   253,   508,   810,   497,   558,   498,   701,   558,
     558,   558,   702,   695,   447,   737,   703,   306,   106,   610,
     704,   860,   696,   434,   418,   594,   436,   604,   384,   596,
     596,   830,   423,   597,   597,   613,   594,   615,   594,   617,
     432,   448,   621,   599,   599,   630,   662,   530,   474,   532,
     666,   667,   542,   708,   671,   672,   638,   600,   251,   879,
     777,   107,   310,   738,   648,   711,   578,   717,   600,   476,
     600,   841,   582,   889,   712,   336,   718,   673,   345,   257,
     348,   108,   338,   109,   340,   583,   404,   649,   641,   209,
     594,   594,   705,   638,   110,   353,   702,   -68,   -68,   -68,
     659,   706,   111,   611,   707,   833,   -68,   406,   704,   702,
     112,   509,   596,   596,   274,   777,   597,   597,   255,   605,
     777,   113,   600,   600,   211,   641,   599,   599,   669,   648,
     716,   370,   166,   748,   749,   625,   638,   429,   638,   648,
     256,   422,   266,   267,   773,   268,   269,   163,   608,   227,
     372,   560,   649,   270,   427,   777,   777,   777,   777,   412,
     431,   254,   649,   271,   777,   777,   777,   529,   641,   778,
     641,   648,   777,   594,   594,   486,   307,   487,   488,   474,
     731,   732,   733,   734,   558,   736,   385,   267,   757,   268,
     269,   419,   435,   420,   649,   437,   831,   270,   763,   424,
     476,   425,   781,   233,   514,   600,   600,   433,   784,   783,
     663,   630,   767,   531,   664,   533,   252,   773,   543,   709,
     791,   311,   262,   638,   638,   638,   638,   638,   638,   638,
     638,   638,   638,   780,   337,   500,   346,   347,   349,   350,
     513,   339,   778,   341,   500,   405,   558,   558,   558,   558,
     397,   558,   864,   354,   355,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   641,   596,   407,   234,   235,   597,
     510,   229,   773,   872,   256,   236,   257,   773,   606,   599,
     787,   314,   788,   234,   235,   316,   856,   779,   231,   371,
     626,   236,   238,   240,   627,   474,   574,   778,   242,   628,
     815,   114,   778,   818,   244,   228,   780,   609,   373,   816,
     275,   526,   773,   773,   773,   773,   476,   413,   847,   247,
     249,   773,   773,   773,   127,   282,   594,   129,   131,   773,
     820,   853,   836,   558,   767,   284,   286,   778,   778,   778,
     778,   718,   294,   115,   133,   840,   778,   778,   778,   296,
     298,   234,   235,   300,   778,   558,   234,   235,   600,   236,
     779,   780,   -30,   785,   236,   116,   780,   627,   474,   302,
     304,   308,   628,   592,   312,   603,   318,   320,   256,   607,
     257,   834,   117,   753,   592,   704,   592,   322,   324,   476,
     135,   326,   328,   629,   330,   137,   332,   193,   865,   866,
     195,   780,   780,   780,   780,   118,   398,   334,   399,   343,
     780,   780,   780,  -318,  -318,   779,   215,   119,   780,   837,
     779,   660,   351,   356,   358,   360,   362,   230,   838,   234,
     235,   657,   364,   234,   235,  -318,   366,   236,   592,   592,
     368,   236,   217,   753,   232,   374,   120,   128,   239,   241,
     130,   132,   121,   376,   243,   779,   779,   779,   779,   378,
     245,   122,   380,   275,   779,   779,   779,   134,   123,   382,
     387,   124,   779,   389,   391,   248,   250,   393,   715,   395,
     857,   283,   458,   459,   460,   461,   462,   463,   464,   -66,
     408,   285,   287,   410,   415,   125,   660,   769,   295,   466,
    -408,  -408,   770,   467,   468,   297,   299,   469,   470,   301,
     753,   213,   126,   136,   671,   672,   234,   235,   138,   501,
     194,   592,   592,   196,   236,   303,   305,   309,   697,   139,
     313,   140,   319,   321,   857,   755,   458,   459,   460,   461,
     462,   463,   464,   323,   325,   751,   762,   327,   329,   219,
     331,   769,   333,   466,  -406,  -406,   770,   467,   468,   629,
     141,   469,   470,   335,   221,   344,   142,   857,   790,   458,
     459,   460,   461,   462,   463,   464,   264,   143,   352,   357,
     359,   361,   363,   760,   769,   225,   466,   144,   365,   770,
     467,   468,   367,   342,   469,   470,   369,   223,   471,   472,
     857,   375,   458,   459,   460,   461,   462,   463,   464,   377,
     756,   474,   -66,   -66,   -66,   379,   288,   769,   381,   466,
     145,   -66,   770,   467,   468,   383,   388,   469,   470,   390,
     392,   146,   476,   394,   486,   396,   487,   488,   473,   844,
     474,   289,   502,   503,   504,   771,   409,   147,  -408,   411,
     416,   505,   471,   472,   671,   672,   148,   234,   235,   671,
     672,   476,   671,   672,   149,   236,   846,   150,   699,   474,
     851,   290,   151,   745,   592,   525,   870,   152,  -317,  -317,
     268,   269,   752,   153,   154,   471,   472,   155,   270,   156,
     476,   157,   473,   158,   474,   291,   234,   235,   159,   771,
    -317,   160,  -406,   602,   236,   234,   235,   161,   474,   876,
     877,   878,   164,   236,   167,   476,   761,   474,   471,   472,
     268,   269,   752,   499,   168,   473,   169,   474,   270,   476,
     385,   267,   771,   268,   269,   858,   292,   170,   476,   171,
     172,   270,   726,   727,   728,   729,   730,   556,   476,   458,
     459,   460,   461,   462,   463,   464,   173,   174,   473,   175,
     474,   234,   235,   176,   465,   771,   466,   177,  -410,   236,
     467,   468,   845,   474,   469,   470,   178,   179,   180,   181,
     556,   476,   458,   459,   460,   461,   462,   463,   464,   182,
     234,   235,   183,   184,   476,   185,   402,   465,   236,   466,
     186,   714,   474,   467,   468,   828,   187,   469,   470,   188,
     189,   556,   190,   458,   459,   460,   461,   462,   463,   464,
     191,   234,   235,   476,   192,   441,   197,   198,   465,   236,
     466,   199,   789,   474,   467,   468,   200,   201,   469,   470,
     556,   202,   458,   459,   460,   461,   462,   463,   464,   203,
     234,   235,   204,   205,   476,   293,   400,   465,   236,   466,
     859,   656,   401,   467,   468,   471,   472,   469,   470,   556,
     440,   458,   459,   460,   461,   462,   463,   464,   452,   670,
     385,   267,   268,   268,   269,   444,   465,   403,   466,   417,
     438,   270,   467,   468,   439,   -35,   469,   470,   471,   472,
     828,   828,   828,   446,   453,   473,   450,   474,   454,   859,
     859,   859,   475,   515,   256,   557,   266,   267,   456,   268,
     269,   455,   719,   457,   720,   234,   235,   270,   476,   471,
     472,   512,   516,   236,   517,   519,   850,   271,   473,   518,
     474,   520,   521,   561,   522,   475,   562,   555,   563,   674,
     675,   676,   677,   678,   679,   680,   681,   523,   471,   472,
     524,   476,   534,   535,   536,   537,   538,   539,   540,   473,
     541,   474,   569,   564,   573,   565,   475,   570,   576,   566,
     510,   577,   581,   587,   571,   601,   618,   471,   472,   622,
     572,   580,   476,   586,   620,   632,   633,   646,   473,   642,
     474,   643,   653,   644,   645,   475,   647,   665,   567,   793,
     794,   795,   796,   797,   798,   799,   800,   801,   802,   658,
     687,   476,   688,   689,   691,   693,   690,   473,   692,   474,
     694,   698,   700,   713,   475,   739,   556,   568,   458,   459,
     460,   461,   462,   463,   464,   710,   740,   735,   742,   744,
     476,   750,   758,   465,   759,   466,   768,   782,   811,   467,
     468,   807,   812,   469,   470,   556,   809,   458,   459,   460,
     461,   462,   463,   464,   813,   814,   819,   820,   824,   825,
     829,   832,   465,   835,   466,   839,   842,   843,   467,   468,
     861,   852,   469,   470,   556,   867,   458,   459,   460,   461,
     462,   463,   464,   863,   871,   868,   873,   869,   874,   875,
     880,   465,   882,   466,   881,   883,   884,   467,   468,   885,
     886,   469,   470,   556,   887,   458,   459,   460,   461,   462,
     463,   464,   888,   890,   892,   891,   893,   894,   895,   896,
     465,   897,   466,   898,   899,   900,   467,   468,   901,   451,
     469,   470,   208,   263,   471,   472,   741,   579,   556,   445,
     458,   459,   460,   461,   462,   463,   464,   743,   854,   849,
     624,   786,     0,     0,     0,   465,     0,   466,     0,     0,
       0,   467,   468,   471,   472,   469,   470,     0,     0,     0,
       0,     0,     0,     0,   473,     0,   474,     0,     0,     0,
       0,   475,     0,     0,   746,     0,     0,     0,     0,     0,
       0,     0,   471,   472,     0,     0,     0,   476,     0,     0,
       0,     0,     0,   473,     0,   474,     0,     0,     0,     0,
     475,     0,     0,   803,     0,     0,     0,     0,     0,     0,
       0,   471,   472,     0,     0,     0,   476,     0,     0,     0,
       0,     0,   473,     0,   474,     0,     0,     0,     0,   475,
       0,     0,   804,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,     0,     0,   476,   471,   472,     0,   465,
       0,   473,     0,   474,     0,     0,     0,     0,   475,   469,
     470,   805,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,     0,     0,   476,   556,     0,   458,   459,   460,
     461,   462,   463,   464,     0,     0,   473,     0,   474,   747,
       0,     0,   465,   475,   466,     0,   806,     0,   467,   468,
       0,     0,   469,   470,     0,     0,     0,     0,   556,   476,
     458,   459,   460,   461,   462,   463,   464,     0,     0,     0,
       0,     0,     0,     0,     0,   465,     0,   466,     0,     0,
       0,   467,   468,     0,     0,   469,   470,     0,     0,   556,
       0,   458,   459,   460,   461,   462,   463,   464,     0,     0,
     471,   472,     0,     0,     0,     0,   465,     0,   466,   544,
       0,     0,   467,   468,     0,     0,   469,   470,   545,   546,
     547,   548,   549,   550,   551,   552,   553,     0,     0,     0,
     234,   235,     0,     0,     0,   588,     0,     0,   236,     0,
     473,     0,   474,   471,   472,     0,     0,     0,   589,   590,
       0,   591,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,     0,   476,   792,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,     0,   471,   472,     0,     0,
       0,     0,     0,   473,     0,   474,     0,     0,     0,     0,
     475,     0,     0,   808,     0,     0,     0,     0,     0,   458,
     459,   460,   461,   462,   463,   464,   476,   471,   472,     0,
       0,     0,     0,     0,     0,     0,   473,     0,   474,     0,
       0,     0,     0,   475,   469,   470,   848,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   476,
       0,     0,     0,     0,     0,     0,     0,   473,     0,   474,
       0,     0,     0,     0,   475,     0,     0,   862,   458,   459,
     460,   461,   462,   463,   464,     0,     0,     0,     0,     0,
     476,     0,     0,   769,     0,   466,     0,     0,   770,   467,
     468,     0,     0,   469,   470,   458,   459,   460,   461,   462,
     463,   464,     0,     0,     0,     0,     0,     0,     0,     0,
     769,     0,   466,     0,     0,   770,   467,   468,     0,     0,
     469,   470,     0,     0,     0,   471,   472,   458,   459,   460,
     461,   462,   463,   464,     0,     0,     0,     0,     0,     0,
       0,     0,   465,     0,   466,     0,     0,     0,   467,   468,
       0,     0,   469,   470,     0,   234,   235,     0,     0,     0,
       0,   634,     0,   236,     0,   473,   635,   474,     0,     0,
       0,     0,     0,   636,     0,   458,   459,   460,   461,   462,
     463,   464,     0,     0,   471,   472,     0,     0,   476,     0,
     465,     0,   466,     0,     0,     0,   467,   468,     0,     0,
     469,   470,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   471,   472,   458,   459,   460,   461,   462,   463,   464,
       0,     0,     0,     0,   473,     0,   474,     0,   465,     0,
     466,   771,     0,   772,   467,   468,     0,     0,   469,   470,
       0,     0,     0,   471,   472,     0,     0,   476,     0,     0,
       0,   473,     0,   474,     0,     0,     0,     0,   771,     0,
       0,   826,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   476,     0,     0,     0,     0,     0,
       0,     0,     0,   473,     0,   474,     0,     0,     0,     0,
     475,   471,   472,   668,   458,   459,   460,   461,   462,   463,
     464,     0,     0,     0,     0,     0,   476,     0,     0,   769,
       0,   466,     0,     0,   770,   467,   468,     0,     0,   469,
     470,     0,   458,   459,   460,   461,   462,   463,   464,   471,
     472,   473,     0,   474,     0,     0,     0,   465,   475,   466,
     765,     0,     0,   467,   468,     0,     0,   469,   470,     0,
       0,     0,     0,     0,   476,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   473,
       0,   474,     0,     0,     0,     0,   475,     0,     0,   817,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   476,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     471,   472,   544,   674,   675,   676,   677,   678,   679,   680,
     681,   545,   546,   547,   548,   549,   550,   551,   552,   553,
       0,     0,     0,     0,     0,     0,     0,     0,   471,   472,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     473,     0,   474,     0,     0,     0,     0,   771,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   476,     0,     0,     0,     0,   473,     0,
     474,    -2,   207,     0,     0,   475,     0,     0,     0,     0,
      -8,   -10,   -12,   -14,   -16,   -18,   -20,   -22,   -24,     0,
       0,   476,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,     0,    15,    16,    17,    18,    19,
       0,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     0,
       0,     0,    88,    89,    90,     0,     0,     0,     0,     0,
       0,     1,     0,     0,     0,     0,     0,     0,     0,    -8,
     -10,   -12,   -14,   -16,   -18,   -20,   -22,   -24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,     0,    15,    16,    17,    18,    19,    91,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     0,     0,
       0,    88,    89,    90,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    91
};

static const yytype_int16 yycheck[] =
{
     110,   123,   424,   461,   523,   115,     1,   429,   523,   431,
       1,   433,     1,     1,    49,   534,     0,   536,   523,   534,
     186,   536,   572,     1,     1,     1,     1,   699,     1,   534,
     580,   536,   422,     1,   479,   425,   534,   427,   536,   149,
     150,     1,     1,   443,   742,   435,   491,   437,   156,   494,
     495,   496,   160,   156,   150,     1,   156,     1,   124,     1,
     160,   832,   165,     1,     1,   523,     1,   525,     1,   588,
     589,     1,     1,   588,   589,   533,   534,   535,   536,   537,
       1,   177,   539,   588,   589,   543,     1,     1,   161,     1,
     588,   589,     1,     1,   142,   143,   554,   523,     1,   870,
     772,   124,     1,   653,   157,   156,   506,   156,   534,   182,
     536,   809,   154,   884,   165,     1,   165,   165,     1,   159,
       1,   124,     1,   124,     1,   167,     1,   180,   554,     9,
     588,   589,   156,   591,   124,     1,   160,   172,   173,   174,
     180,   165,   124,   533,   156,   156,   181,     1,   160,   160,
     124,     1,   671,   672,   276,   827,   671,   672,     1,     1,
     832,   124,   588,   589,    10,   591,   671,   672,   590,   157,
     628,     1,   167,   671,   672,     1,   634,   168,   636,   157,
     157,   170,   159,   160,   699,   162,   163,   160,     1,     1,
       1,   166,   180,   170,   170,   867,   868,   869,   870,     1,
     168,   160,   180,   180,   876,   877,   878,   167,   634,   699,
     636,   157,   884,   671,   672,   157,   160,   159,   160,   161,
     642,   643,   644,   645,   669,   647,   159,   160,   686,   162,
     163,   168,   170,   170,   180,   170,   166,   170,   696,   168,
     182,   170,   700,     1,     1,   671,   672,   168,     1,   706,
     165,   709,   697,   167,   169,   167,   159,   772,   167,   167,
     718,   160,     1,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   699,   160,   441,   159,   160,   159,   160,
     446,   160,   772,   160,   450,   160,   731,   732,   733,   734,
       1,   736,   842,   159,   160,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   824,   160,   149,   150,   824,
     160,     1,   827,   863,   157,   157,   159,   832,   160,   824,
     710,     1,   712,   149,   150,     1,   824,   699,     1,   159,
     156,   157,     1,     1,   160,   161,   502,   827,     1,   165,
     156,   124,   832,   765,     1,   157,   772,   160,   159,   165,
     123,   461,   867,   868,   869,   870,   182,   159,   816,     1,
       1,   876,   877,   878,     1,     1,   824,     1,     1,   884,
      21,    22,   156,   818,   819,     1,     1,   867,   868,   869,
     870,   165,     1,   124,     1,   807,   876,   877,   878,     1,
       1,   149,   150,     1,   884,   840,   149,   150,   824,   157,
     772,   827,   159,   156,   157,   124,   832,   160,   161,     1,
       1,     1,   165,   523,     1,   525,     1,     1,   157,   529,
     159,   156,   124,   682,   534,   160,   536,     1,     1,   182,
       1,     1,     1,   543,     1,     1,     1,     1,   186,   187,
       1,   867,   868,   869,   870,   124,   157,     1,   159,     1,
     876,   877,   878,   160,   161,   827,    12,   124,   884,   156,
     832,   583,     1,     1,     1,     1,     1,   157,   165,   149,
     150,   581,     1,   149,   150,   182,     1,   157,   588,   589,
       1,   157,    13,   742,   157,     1,   124,   124,   157,   157,
     124,   124,   124,     1,   157,   867,   868,   869,   870,     1,
     157,   124,     1,   276,   876,   877,   878,   124,   124,     1,
       1,   124,   884,     1,     1,   157,   157,     1,   628,     1,
       1,   157,     3,     4,     5,     6,     7,     8,     9,    49,
       1,   157,   157,     1,     1,   124,   658,    18,   157,    20,
      21,    22,    23,    24,    25,   157,   157,    28,    29,   157,
     809,    11,   124,   124,   142,   143,   149,   150,   124,    49,
     124,   671,   672,   124,   157,   157,   157,   157,   156,   124,
     157,   124,   157,   157,     1,   685,     3,     4,     5,     6,
       7,     8,     9,   157,   157,    27,   696,   157,   157,    14,
     157,    18,   157,    20,    21,    22,    23,    24,    25,   709,
     124,    28,    29,   157,    15,   157,   124,     1,   718,     3,
       4,     5,     6,     7,     8,     9,   160,   124,   157,   157,
     157,   157,   157,    27,    18,    17,    20,   124,   157,    23,
      24,    25,   157,   160,    28,    29,   157,    16,   119,   120,
       1,   157,     3,     4,     5,     6,     7,     8,     9,   157,
     160,   161,   172,   173,   174,   157,   157,    18,   157,    20,
     124,   181,    23,    24,    25,   157,   157,    28,    29,   157,
     157,   124,   182,   157,   157,   157,   159,   160,   159,    27,
     161,   157,   172,   173,   174,   166,   157,   124,   169,   157,
     157,   181,   119,   120,   142,   143,   124,   149,   150,   142,
     143,   182,   142,   143,   124,   157,   816,   124,   156,   161,
     820,   157,   124,   156,   824,   167,   156,   124,   160,   161,
     162,   163,   164,   124,   124,   119,   120,   124,   170,   124,
     182,   124,   159,   124,   161,   157,   149,   150,   124,   166,
     182,   124,   169,   156,   157,   149,   150,   124,   161,   867,
     868,   869,   124,   157,   124,   182,   160,   161,   119,   120,
     162,   163,   164,   152,   124,   159,   124,   161,   170,   182,
     159,   160,   166,   162,   163,   169,   157,   124,   182,   124,
     124,   170,   149,   150,   151,   152,   153,     1,   182,     3,
       4,     5,     6,     7,     8,     9,   124,   124,   159,   124,
     161,   149,   150,   124,    18,   166,    20,   124,   169,   157,
      24,    25,   160,   161,    28,    29,   124,   124,   124,   124,
       1,   182,     3,     4,     5,     6,     7,     8,     9,   124,
     149,   150,   124,   124,   182,   124,   159,    18,   157,    20,
     124,   160,   161,    24,    25,   772,   124,    28,    29,   124,
     124,     1,   124,     3,     4,     5,     6,     7,     8,     9,
     124,   149,   150,   182,   124,   179,   124,   124,    18,   157,
      20,   124,   160,   161,    24,    25,   124,   124,    28,    29,
       1,   124,     3,     4,     5,     6,     7,     8,     9,   124,
     149,   150,   124,   124,   182,   157,   157,    18,   157,    20,
     827,   160,   157,    24,    25,   119,   120,    28,    29,     1,
       1,     3,     4,     5,     6,     7,     8,     9,   174,   591,
     159,   160,   162,   162,   163,   179,    18,   157,    20,   157,
     157,   170,    24,    25,   157,   179,    28,    29,   119,   120,
     867,   868,   869,   179,   165,   159,   179,   161,   174,   876,
     877,   878,   166,   159,   157,   169,   159,   160,   183,   162,
     163,   179,   634,   174,   636,   149,   150,   170,   182,   119,
     120,   171,   159,   157,   160,   168,   160,   180,   159,   159,
     161,   157,   159,   171,   167,   166,   171,   166,   169,   125,
     126,   127,   128,   129,   130,   131,   132,   167,   119,   120,
     167,   182,   167,   167,   167,   167,   167,   167,   167,   159,
     167,   161,   165,   171,   159,   171,   166,   171,   157,   169,
     160,   159,   165,   156,   179,   156,   160,   119,   120,   159,
     179,   179,   182,   185,   160,    27,    27,   157,   159,   168,
     161,   168,   179,   168,   168,   166,   168,   157,   169,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   167,
     156,   182,   156,   156,   165,   165,   156,   159,   156,   161,
     156,   156,    26,   156,   166,   156,     1,   169,     3,     4,
       5,     6,     7,     8,     9,   165,   156,   171,   165,   153,
     182,   160,   160,    18,   160,    20,   168,   160,    25,    24,
      25,   168,   156,    28,    29,     1,   165,     3,     4,     5,
       6,     7,     8,     9,   156,   156,    19,    21,   167,   166,
     166,   156,    18,   156,    20,   156,   165,   157,    24,    25,
     157,   169,    28,    29,     1,   179,     3,     4,     5,     6,
       7,     8,     9,   165,   156,   179,   165,   179,   184,   157,
     165,    18,   157,    20,   160,   184,    19,    24,    25,   160,
     156,    28,    29,     1,   185,     3,     4,     5,     6,     7,
       8,     9,   157,   156,   185,   157,   153,   157,    25,   153,
      18,   157,    20,    25,   186,   157,    24,    25,   186,   276,
      28,    29,    93,   121,   119,   120,   658,   510,     1,   270,
       3,     4,     5,     6,     7,     8,     9,   663,   822,   819,
     541,   709,    -1,    -1,    -1,    18,    -1,    20,    -1,    -1,
      -1,    24,    25,   119,   120,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   159,    -1,   161,    -1,    -1,    -1,
      -1,   166,    -1,    -1,   169,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,   120,    -1,    -1,    -1,   182,    -1,    -1,
      -1,    -1,    -1,   159,    -1,   161,    -1,    -1,    -1,    -1,
     166,    -1,    -1,   169,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   119,   120,    -1,    -1,    -1,   182,    -1,    -1,    -1,
      -1,    -1,   159,    -1,   161,    -1,    -1,    -1,    -1,   166,
      -1,    -1,   169,    -1,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,   182,   119,   120,    -1,    18,
      -1,   159,    -1,   161,    -1,    -1,    -1,    -1,   166,    28,
      29,   169,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,    -1,   182,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,   159,    -1,   161,   171,
      -1,    -1,    18,   166,    20,    -1,   169,    -1,    24,    25,
      -1,    -1,    28,    29,    -1,    -1,    -1,    -1,     1,   182,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    28,    29,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    -1,    -1,
     119,   120,    -1,    -1,    -1,    -1,    18,    -1,    20,   124,
      -1,    -1,    24,    25,    -1,    -1,    28,    29,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,    -1,    -1,
     149,   150,    -1,    -1,    -1,   154,    -1,    -1,   157,    -1,
     159,    -1,   161,   119,   120,    -1,    -1,    -1,   167,   168,
      -1,   170,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   182,   156,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   119,   120,    -1,    -1,
      -1,    -1,    -1,   159,    -1,   161,    -1,    -1,    -1,    -1,
     166,    -1,    -1,   169,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,   182,   119,   120,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   159,    -1,   161,    -1,
      -1,    -1,    -1,   166,    28,    29,   169,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,    -1,   161,
      -1,    -1,    -1,    -1,   166,    -1,    -1,   169,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
     182,    -1,    -1,    18,    -1,    20,    -1,    -1,    23,    24,
      25,    -1,    -1,    28,    29,     3,     4,     5,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    -1,    20,    -1,    -1,    23,    24,    25,    -1,    -1,
      28,    29,    -1,    -1,    -1,   119,   120,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    -1,    20,    -1,    -1,    -1,    24,    25,
      -1,    -1,    28,    29,    -1,   149,   150,    -1,    -1,    -1,
      -1,   155,    -1,   157,    -1,   159,   160,   161,    -1,    -1,
      -1,    -1,    -1,   167,    -1,     3,     4,     5,     6,     7,
       8,     9,    -1,    -1,   119,   120,    -1,    -1,   182,    -1,
      18,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,    -1,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   119,   120,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,   159,    -1,   161,    -1,    18,    -1,
      20,   166,    -1,   168,    24,    25,    -1,    -1,    28,    29,
      -1,    -1,    -1,   119,   120,    -1,    -1,   182,    -1,    -1,
      -1,   159,    -1,   161,    -1,    -1,    -1,    -1,   166,    -1,
      -1,   169,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   159,    -1,   161,    -1,    -1,    -1,    -1,
     166,   119,   120,   169,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,   182,    -1,    -1,    18,
      -1,    20,    -1,    -1,    23,    24,    25,    -1,    -1,    28,
      29,    -1,     3,     4,     5,     6,     7,     8,     9,   119,
     120,   159,    -1,   161,    -1,    -1,    -1,    18,   166,    20,
     168,    -1,    -1,    24,    25,    -1,    -1,    28,    29,    -1,
      -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,
      -1,   161,    -1,    -1,    -1,    -1,   166,    -1,    -1,   169,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,   120,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159,    -1,   161,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,   159,    -1,
     161,     0,     1,    -1,    -1,   166,    -1,    -1,    -1,    -1,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    -1,
      -1,   182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
      -1,    -1,   121,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,   178,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,    -1,
      -1,   121,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    44,    45,    46,    47,    48,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   121,   122,
     123,   178,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   223,   224,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,     1,   124,     1,
     124,     1,   124,     1,   124,     1,   124,     1,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,     1,   160,   124,     1,   167,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,     1,   124,     1,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,     0,     1,   192,     9,
     233,    10,   234,    11,   235,    12,   236,    13,   237,    14,
     238,    15,   239,    16,   240,    17,   241,     1,   157,     1,
     157,     1,   157,     1,   149,   150,   157,   207,     1,   157,
       1,   157,     1,   157,     1,   157,   207,     1,   157,     1,
     157,     1,   159,     1,   160,     1,   157,   159,   205,   208,
     209,   215,     1,   215,   160,     1,   159,   160,   162,   163,
     170,   180,   202,   204,   205,   208,   210,   211,   225,   226,
     227,   228,     1,   157,     1,   157,     1,   157,   157,   157,
     157,   157,   157,   157,     1,   157,     1,   157,     1,   157,
       1,   157,     1,   157,     1,   157,     1,   160,     1,   157,
       1,   160,     1,   157,     1,   207,     1,   207,     1,   157,
       1,   157,     1,   157,     1,   157,     1,   157,     1,   157,
       1,   157,     1,   157,     1,   157,     1,   160,     1,   160,
       1,   160,   160,     1,   157,     1,   159,   160,     1,   159,
     160,     1,   157,     1,   159,   160,     1,   157,     1,   157,
       1,   157,     1,   157,     1,   157,     1,   157,     1,   157,
       1,   159,     1,   159,     1,   157,     1,   157,     1,   157,
       1,   157,     1,   157,     1,   159,   202,     1,   157,     1,
     157,     1,   157,     1,   157,     1,   157,     1,   157,   159,
     157,   157,   159,   157,     1,   160,     1,   160,     1,   157,
       1,   157,     1,   159,   222,     1,   157,   157,     1,   168,
     170,     1,   170,     1,   168,   170,     1,   170,     1,   168,
       1,   168,     1,   168,     1,   170,     1,   170,   157,   157,
       1,   179,   217,   216,   179,   227,   179,   150,   177,   203,
     179,   211,   174,   165,   174,   179,   183,   174,     3,     4,
       5,     6,     7,     8,     9,    18,    20,    24,    25,    28,
      29,   119,   120,   159,   161,   166,   182,   248,   253,   257,
     259,   262,   263,   264,   265,   273,   157,   159,   160,   231,
     231,   257,   231,   231,   257,   257,   257,   231,   231,   152,
     202,    49,   172,   173,   174,   181,   213,   214,   214,     1,
     160,   219,   171,   202,     1,   159,   159,   160,   159,   168,
     157,   159,   167,   167,   167,   167,   207,   248,     1,   167,
       1,   167,     1,   167,   167,   167,   167,   167,   167,   167,
     167,   167,     1,   167,   124,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   251,   166,     1,   169,   259,     1,
     166,   171,   171,   169,   171,   171,   169,   169,   169,   165,
     171,   179,   179,   159,   202,   212,   157,   159,   214,   219,
     179,   165,   154,   167,   220,   221,   185,   156,   154,   167,
     168,   170,   207,   242,   248,   249,   250,   253,   254,   262,
     273,   156,   156,   207,   248,     1,   160,   207,     1,   160,
       1,   231,   232,   248,   242,   248,   242,   248,   160,   230,
     160,   230,   159,   272,   272,     1,   156,   160,   165,   207,
     248,   270,    27,    27,   155,   160,   167,   207,   248,   250,
     252,   273,   168,   168,   168,   168,   157,   168,   157,   180,
     206,     1,   206,   179,     1,   206,   160,   207,   167,   180,
     205,   218,     1,   165,   169,   157,   242,   242,   169,   257,
     252,   142,   143,   165,   125,   126,   127,   128,   129,   130,
     131,   132,   243,   244,   245,   246,   247,   156,   156,   156,
     156,   165,   156,   165,   156,   156,   165,   156,   156,   156,
      26,   156,   160,   156,   160,   156,   165,   156,     1,   167,
     165,   156,   165,   156,   160,   207,   248,   156,   165,   252,
     252,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   257,   257,   257,   257,   171,   257,     1,   206,   156,
     156,   218,   165,   220,   153,   156,   169,   171,   242,   242,
     160,    27,   164,   225,   229,   207,   160,   248,   160,   160,
      27,   160,   207,   248,   271,   168,   256,   259,   168,    18,
      23,   166,   168,   253,   255,   260,   261,   263,   264,   265,
     273,   248,   160,   230,     1,   156,   270,   231,   231,   160,
     207,   248,   156,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   169,   169,   169,   169,   168,   169,   165,
     229,    25,   156,   156,   156,   156,   165,   169,   257,    19,
      21,   266,   267,   268,   167,   166,   169,   258,   260,   166,
       1,   166,   156,   156,   156,   156,   156,   156,   165,   156,
     257,   229,   165,   157,    27,   160,   207,   248,   169,   256,
     160,   207,   169,    22,   268,   269,   242,     1,   169,   260,
     255,   157,   169,   165,   206,   186,   187,   179,   179,   179,
     156,   156,   206,   165,   184,   157,   258,   258,   258,   255,
     165,   160,   157,   184,    19,   160,   156,   185,   157,   255,
     156,   157,   185,   153,   157,    25,   153,   157,    25,   186,
     157,   186
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   189,   190,   191,   191,   191,   192,   192,   193,   192,
     194,   192,   195,   192,   196,   192,   197,   192,   198,   192,
     199,   192,   200,   192,   201,   192,   192,   202,   202,   202,
     203,   203,   204,   204,   204,   205,   206,   206,   207,   207,
     207,   208,   208,   208,   208,   209,   209,   210,   210,   210,
     210,   210,   211,   211,   212,   212,   212,   213,   213,   213,
     213,   213,   214,   214,   215,   215,   216,   215,   217,   215,
     218,   218,   219,   219,   220,   220,   221,   221,   221,   222,
     222,   222,   222,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   224,   224,   224,   224,   224,   225,   225,   226,   227,
     228,   228,   229,   229,   230,   230,   231,   231,   231,   232,
     232,   233,   233,   233,   234,   234,   235,   235,   235,   236,
     236,   237,   237,   238,   238,   239,   239,   240,   240,   241,
     241,   242,   242,   242,   242,   242,   242,   243,   243,   244,
     244,   244,   244,   245,   245,   246,   246,   247,   247,   247,
     248,   248,   249,   249,   249,   249,   250,   250,   250,   250,
     250,   251,   251,   251,   251,   251,   251,   251,   251,   251,
     251,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   252,   252,   252,   252,   253,   253,
     253,   254,   254,   254,   254,   254,   255,   255,   255,   256,
     256,   256,   257,   257,   257,   258,   258,   258,   259,   259,
     259,   259,   259,   259,   259,   259,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   261,   261,   262,   262,   263,
     264,   265,   266,   266,   267,   267,   268,   268,   268,   268,
     269,   269,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   271,   271,   271,   271,   271,   271,   271,
     271,   272,   272,   272,   272,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     2,
       2,     3,     5,     5,     2,     3,     5,     1,     3,     5,
       5,     1,     1,     2,     1,     3,     3,     1,     2,     2,
       2,     2,     1,     2,     1,     1,     0,     3,     0,     3,
       1,     1,     1,     2,     9,    10,     3,     1,     2,    18,
      17,    10,     9,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     3,     3,     3,     3,     5,
       3,     3,     5,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     5,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     5,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     2,     7,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     2,     8,     8,     2,     1,     1,     1,     1,
       1,     3,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     4,     7,     2,     7,     2,     4,     7,     2,     7,
       2,     4,     2,     4,     2,     4,     2,     9,     2,     7,
       2,     3,     3,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     3,     3,
       3,     1,     1,     1,     3,     2,     1,     3,     2,     1,
       3,     2,     2,     1,     2,     2,     1,     2,     2,     1,
       1,     1,     1,     2,     1,     2,     2,     2,     1,     1,
       1,     1,     2,     1,     2,     5,     7,     5,     7,     5,
       7,     7,     2,     1,     2,     1,     4,     3,     4,     3,
       3,     2,     1,     3,     1,     2,     2,     1,     2,     3,
       1,     2,     3,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     4,     4,     2,     6,     1,     3,     1,     3,
       2,     4,     2,     4,     3,     1,     4,     6,     2,     4,
       6,     2,     4,     4,     6,     2,     4,     3,     4,     4,
       2,     4,     4,     4,     4,     6,     6,     6,     8,     6,
       4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 484 "cfg.y" /* yacc.c:1646  */
    {}
#line 2518 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 485 "cfg.y" /* yacc.c:1646  */
    {}
#line 2524 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 486 "cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 2530 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 491 "cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 2536 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 492 "cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 2542 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 493 "cfg.y" /* yacc.c:1646  */
    {rt=ONREPLY_ROUTE;}
#line 2548 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 494 "cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 2554 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 495 "cfg.y" /* yacc.c:1646  */
    {rt=ERROR_ROUTE;}
#line 2560 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 496 "cfg.y" /* yacc.c:1646  */
    {rt=LOCAL_ROUTE;}
#line 2566 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 497 "cfg.y" /* yacc.c:1646  */
    {rt=STARTUP_ROUTE;}
#line 2572 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 498 "cfg.y" /* yacc.c:1646  */
    {rt=TIMER_ROUTE;}
#line 2578 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 499 "cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 2584 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 504 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2604 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 519 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2618 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 528 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2636 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 543 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)=".";}
#line 2642 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 544 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)="-"; }
#line 2648 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 547 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 2654 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 548 "cfg.y" /* yacc.c:1646  */
    { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2673 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 562 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2681 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 567 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2694 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 577 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2700 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 578 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 2706 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 581 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2712 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 582 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2718 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 583 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 2724 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 587 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2731 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 589 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2738 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 591 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2748 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 596 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2757 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 602 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2764 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 604 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 2771 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 608 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2778 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 610 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2785 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 612 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2792 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 614 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2801 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 621 "cfg.y" /* yacc.c:1646  */
    { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2807 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 622 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2813 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 625 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2820 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 627 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2827 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 629 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2836 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 635 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 2844 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 638 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 2852 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 641 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 2860 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 644 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 2868 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 647 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 2876 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 656 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2882 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 657 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2888 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 658 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2896 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 660 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2904 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 663 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2912 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 665 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2920 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 670 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_NONE; }
#line 2926 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 671 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2932 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 673 "cfg.y" /* yacc.c:1646  */
    {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 2938 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 674 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 2944 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 677 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2957 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 685 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2971 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 696 "cfg.y" /* yacc.c:1646  */
    {}
#line 2977 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 697 "cfg.y" /* yacc.c:1646  */
    {}
#line 2983 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 698 "cfg.y" /* yacc.c:1646  */
    { yyerror("bad black list element");}
#line 2989 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 705 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 2999 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 713 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3009 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 719 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3019 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 725 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3029 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 732 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 3038 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 736 "cfg.y" /* yacc.c:1646  */
    { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 3044 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 737 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3050 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 738 "cfg.y" /* yacc.c:1646  */
    { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 3056 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 739 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3062 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 740 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) { *log_level = L_DBG;log_stderr=1;}
			}
#line 3071 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 745 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected for debug_mode"); }
#line 3077 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 748 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_stdout=(yyvsp[0].intval); }
#line 3083 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 749 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3089 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 753 "cfg.y" /* yacc.c:1646  */
    { IFOR(); if (!config_check && !debug_mode) log_stderr=(yyvsp[0].intval); }
#line 3095 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 754 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3101 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 755 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3112 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 761 "cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 3118 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 762 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_name=(yyvsp[0].strval); }
#line 3124 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 763 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3130 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 764 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3136 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 765 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3142 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 766 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3148 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 767 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3154 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 768 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3160 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 769 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3166 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 770 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3172 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 771 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3178 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 772 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3184 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 773 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3190 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 774 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3196 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 775 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3202 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 776 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3208 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 777 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3214 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 778 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3220 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 779 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3226 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 780 "cfg.y" /* yacc.c:1646  */
    { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3232 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 781 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3238 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 782 "cfg.y" /* yacc.c:1646  */
    { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3244 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 783 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3250 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 784 "cfg.y" /* yacc.c:1646  */
    { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3256 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 785 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3265 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 789 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3271 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 790 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3279 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 793 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3288 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 797 "cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 3294 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 798 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3300 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 799 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3313 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 807 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3326 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 815 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3339 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 823 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3352 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 831 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3365 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 839 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3378 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 847 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3391 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 855 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3404 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 863 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3417 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 871 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3430 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 879 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 3438 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 882 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3444 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 883 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 3452 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 886 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3458 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 887 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 3464 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 888 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3470 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 889 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memdump=(yyvsp[0].intval); }
#line 3476 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 890 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3482 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 891 "cfg.y" /* yacc.c:1646  */
    {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 3488 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 892 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3494 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 893 "cfg.y" /* yacc.c:1646  */
    { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 3500 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 894 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3506 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 895 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 3512 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 896 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3518 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 897 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 3533 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 907 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3539 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 908 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 3558 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 922 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3564 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 923 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 3570 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 924 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3576 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 925 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 3582 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 926 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3588 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 927 "cfg.y" /* yacc.c:1646  */
    { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 3594 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 928 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3600 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 929 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3606 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 930 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3612 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 931 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3618 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 932 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3624 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 933 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3630 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 934 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3636 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 935 "cfg.y" /* yacc.c:1646  */
    { IFOR(); mhomed=(yyvsp[0].intval); }
#line 3642 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 936 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3648 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 937 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 3663 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 947 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 3678 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 957 "cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 3684 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 958 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 3692 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 961 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3698 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 962 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 3706 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 965 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3715 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 969 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3721 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 970 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 3729 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 973 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3735 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 974 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 3743 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 977 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3749 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 978 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				warn("tcp_listen_backlog is deprecated, use tcp_socket_backlog");
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 3758 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 982 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3764 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 983 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 3772 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 986 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3778 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 987 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 3786 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 990 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3792 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 991 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 3804 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 998 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 3810 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 999 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 3822 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1006 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 3828 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1008 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_keepalive=(yyvsp[0].intval);
		}
#line 3836 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1011 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3842 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1012 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 3850 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1015 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3856 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1016 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 3868 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1023 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3874 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1024 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 3886 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1031 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3892 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1032 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 3904 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1039 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3910 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1040 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 3917 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1042 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3923 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1043 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_header->s=(yyvsp[0].strval);
							server_header->len=strlen((yyvsp[0].strval));
							}
#line 3932 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1047 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3938 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1048 "cfg.y" /* yacc.c:1646  */
    { user_agent_header->s=(yyvsp[0].strval);
			user_agent_header->len=strlen((yyvsp[0].strval));
									}
#line 3946 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1051 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3952 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1052 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 3959 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1054 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3965 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1055 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 3972 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1057 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 3979 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1059 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 3986 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1061 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3992 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1062 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3998 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1063 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4004 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1064 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 4011 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1066 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4017 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1067 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listening socket\n");
								break;
							}
						}
#line 4029 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1074 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4037 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1077 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 4050 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1085 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4058 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1088 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4107 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1132 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid or no module specified"); }
#line 4113 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1133 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4123 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1138 "cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4130 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1140 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4137 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1142 "cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 4143 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1143 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address->s=(yyvsp[0].strval);
									default_global_address->len=strlen((yyvsp[0].strval));
								}
								}
#line 4154 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1149 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4161 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1151 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port->len)
									default_global_port->s =
									pkg_realloc(default_global_port->s, i_tmp);
								if (!default_global_port->s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port->len = i_tmp;
									memcpy(default_global_port->s, tmp,
											default_global_port->len);
								}
								}
#line 4180 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1165 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4187 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1167 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4195 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1170 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4201 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1171 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4209 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1174 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4215 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1175 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4227 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1182 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4233 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1183 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4245 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1190 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected as tos"); }
#line 4251 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1191 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4260 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1195 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4293 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1223 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4299 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1224 "cfg.y" /* yacc.c:1646  */
    {IFOR();
				set_mpath((yyvsp[0].strval)); }
#line 4306 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1226 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4312 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1227 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4320 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1230 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4326 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1231 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4334 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1234 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4340 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1235 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				s_tmp.s = (yyvsp[-4].strval);
				s_tmp.len = strlen((yyvsp[-4].strval));
				if (create_bl_head( BL_CORE_ID, BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4355 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1245 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4362 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1247 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4369 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1249 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4375 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1250 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 4382 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1252 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4388 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1253 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 4395 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1255 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4403 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1258 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 4410 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1260 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4418 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1263 "cfg.y" /* yacc.c:1646  */
    {}
#line 4424 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1264 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("bad auto-scaling profile definition");
				}
#line 4432 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1267 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 4439 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1269 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4447 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1272 "cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 4453 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1275 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 4462 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1279 "cfg.y" /* yacc.c:1646  */
    { yyerror("string expected");  }
#line 4468 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1280 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4479 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1286 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4490 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1292 "cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 4496 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1296 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4502 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1297 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4508 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1300 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 4527 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1316 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 4546 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1332 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4552 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1333 "cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 4558 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1336 "cfg.y" /* yacc.c:1646  */
    {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 4569 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1342 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 4578 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1352 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4593 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1362 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4608 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1373 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 4616 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1376 "cfg.y" /* yacc.c:1646  */
    {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 4630 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1385 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 4638 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1390 "cfg.y" /* yacc.c:1646  */
    {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 4666 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1413 "cfg.y" /* yacc.c:1646  */
    {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 4675 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1418 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 4688 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1426 "cfg.y" /* yacc.c:1646  */
    {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 4709 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1442 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 4715 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1445 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 4726 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1451 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 4732 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1454 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 4745 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1462 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 4756 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1468 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 4762 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1471 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 4773 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1477 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 4779 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1480 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 4792 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1488 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid error_route statement"); }
#line 4798 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1491 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 4811 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1499 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid local_route statement"); }
#line 4817 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1502 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 4830 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1510 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid startup_route statement"); }
#line 4836 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1513 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = 0;
						while(i_tmp<TIMER_RT_NO && sroutes->timer[i_tmp].a!=0){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].name = (yyvsp[-6].strval);
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 4854 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1526 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid timer_route statement"); }
#line 4860 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1529 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 4871 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1535 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 4877 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1540 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4883 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1541 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 4889 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1542 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 4895 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1543 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 4901 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1544 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[-1].expr); }
#line 4907 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1545 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[0].expr); }
#line 4913 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1548 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 4919 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1549 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 4925 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1552 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 4931 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1553 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 4937 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1554 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 4943 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1555 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 4949 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1557 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 4955 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1558 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=NOTMATCH_OP; }
#line 4961 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1561 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4967 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1562 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4973 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1565 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4979 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1566 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4985 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1567 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4991 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1570 "cfg.y" /* yacc.c:1646  */
    {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 5012 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1586 "cfg.y" /* yacc.c:1646  */
    {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 5020 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1591 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=(yyvsp[0].expr); }
#line 5026 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1592 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5032 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1593 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 5039 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1595 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5047 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1600 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5055 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1603 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 5063 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1606 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 5071 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1609 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 5079 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1612 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 5087 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1618 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = EQ_T; }
#line 5093 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1619 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = COLONEQ_T; }
#line 5099 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1620 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = PLUSEQ_T; }
#line 5105 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1621 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MINUSEQ_T;}
#line 5111 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1622 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = DIVEQ_T; }
#line 5117 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1623 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MULTEQ_T; }
#line 5123 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1624 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MODULOEQ_T; }
#line 5129 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1625 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BANDEQ_T; }
#line 5135 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1626 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BOREQ_T; }
#line 5141 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1627 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BXOREQ_T; }
#line 5147 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1631 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5153 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1632 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5159 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1633 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5165 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1634 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)= (yyvsp[0].expr); }
#line 5171 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1635 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5177 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1636 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5185 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1639 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5193 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1642 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5201 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1645 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5209 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1648 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5217 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1651 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5225 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1654 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5233 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1657 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5241 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1660 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5249 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1663 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5257 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1666 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5265 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1669 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 5271 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1672 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5289 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1685 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5307 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1698 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			/* not all can get NULL with := */
			switch((yyvsp[-2].specval)->type) {
				case PVT_AVP:
				break;
				default:
					yyerror("invalid left operand in NULL assignment");
			}
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5332 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1720 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5338 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1721 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5344 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1722 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5350 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1723 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5356 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1724 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5362 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1727 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5368 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1728 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5374 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1729 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5380 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1732 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5386 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1733 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5392 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1734 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5398 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1737 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5404 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1738 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5410 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1739 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5416 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1743 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5422 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1744 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5428 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1745 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5434 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1748 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5440 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1749 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5446 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1750 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5452 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1751 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5458 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1752 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5464 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1753 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5470 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1754 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 5476 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1755 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5482 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1758 "cfg.y" /* yacc.c:1646  */
    { mk_action0((yyval.action), BREAK_T);}
#line 5488 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1759 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5494 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1760 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5500 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1761 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5506 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1762 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5512 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1763 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5518 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1764 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5524 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1765 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 5530 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1766 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5536 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1769 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5549 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1777 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5562 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1787 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5575 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1795 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5588 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1805 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 5599 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1813 "cfg.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 5620 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1831 "cfg.y" /* yacc.c:1646  */
    {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 5632 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1840 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5638 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1841 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5644 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1843 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5650 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1844 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5656 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1847 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 5667 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1853 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 5678 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1859 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 5689 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1865 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 5700 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1873 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 5708 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1876 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 5714 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1879 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 5724 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1884 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5739 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1894 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 5751 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1901 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 5763 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1908 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 5778 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1918 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 5788 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1923 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 5800 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1930 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5815 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1940 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 5825 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1945 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 5837 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1952 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5852 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1964 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 5862 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1969 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 5872 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1974 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 5882 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1979 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 5892 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1984 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5907 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1994 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5922 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2004 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5937 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2014 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5952 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2026 "cfg.y" /* yacc.c:1646  */
    {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-2].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(cmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 5975 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2044 "cfg.y" /* yacc.c:1646  */
    {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-3].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 6011 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2075 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 6020 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2079 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6029 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2085 "cfg.y" /* yacc.c:1646  */
    {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 6037 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2088 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6043 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2089 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6049 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2090 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6055 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2091 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6061 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2093 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 6067 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2095 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 6073 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2097 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 6079 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2099 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 6085 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2101 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6091 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2102 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6097 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2103 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6105 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2106 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6116 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2112 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6122 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2113 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6129 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2115 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6140 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2121 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6146 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2122 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6153 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2124 "cfg.y" /* yacc.c:1646  */
    {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6161 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2128 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6184 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2147 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6190 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2148 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6197 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2150 "cfg.y" /* yacc.c:1646  */
    {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6225 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2173 "cfg.y" /* yacc.c:1646  */
    {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6266 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2209 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6273 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2211 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6281 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2214 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6288 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2216 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6295 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2218 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6302 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2220 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6309 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2222 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6316 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2224 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6323 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2226 "cfg.y" /* yacc.c:1646  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6334 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2232 "cfg.y" /* yacc.c:1646  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-3].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)(long)i_tmp, (void*)(long)(yyvsp[-1].intval));
				}
#line 6345 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2238 "cfg.y" /* yacc.c:1646  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6356 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2244 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-1].action), (void*)(long)-1);
				}
#line 6365 "cfg.tab.c" /* yacc.c:1646  */
    break;


#line 6369 "cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2251 "cfg.y" /* yacc.c:1906  */


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	s->flags |= param->flags;
	s->workers = param->workers;
	s->auto_scaling_profile = param->auto_scaling_profile;
	if (param->socket)
		set_listen_id_adv(s, param->socket->name, param->socket->port);
	s->tag = param->tag;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
